scoreboard players add @e[tag=pathy] moveDelay 1
execute as @e[tag=pathy,tag=!on_direction,scores={moveDelay=5..}] at @s unless block ~ ~-1 ~ air run function pather:detect_path
execute as @e[tag=pathy,tag=on_direction,scores={moveDelay=5..}] at @s run function pather:move
#replaceitem entity @e[tag=pathy] armor.head stick

# Apply start marker particles
execute at @e[tag=start_marker] run particle portal ~ ~1 ~ 0 0.5 0 0.05 2 force @a[distance=..25]
execute at @e[tag=start_marker] run particle enchant ~ ~ ~ 0 0 0 0.5 1 force @a[distance=..25]

# Run start function after 1 second of sitting in start particles
scoreboard players add @e[tag=start_marker] startDelay 1
execute as @e[tag=start_marker] at @s unless entity @p[distance=..1] run scoreboard players reset @s startDelay
execute as @e[tag=start_marker,scores={startDelay=20..}] at @s run function pather:start

# Give in-game players items
execute as @e[tag=in_game] at @s run function pather:give_items

# Move player back to center of current level if they leave while in spectator mode
execute as @a[gamemode=spectator,tag=!game_master] at @s if score Stage Global matches 1 unless block ~ 53 ~ barrier run tp @s 500 3 500
execute as @a[gamemode=spectator,tag=!game_master] at @s if score Stage Global matches 2 unless block ~ 53 ~ barrier run tp @s 500 3 540
execute as @a[gamemode=spectator,tag=!game_master] at @s if score Stage Global matches 3 unless block ~ 53 ~ barrier run tp @s 500 3 580
execute as @a[gamemode=spectator,tag=!game_master] at @s if score Stage Global matches 4 unless block ~ 53 ~ barrier run tp @s 540 3 500
execute as @a[gamemode=spectator,tag=!game_master] at @s if score Stage Global matches 5 unless block ~ 53 ~ barrier run tp @s 540 3 540
execute as @a[gamemode=spectator,tag=!game_master] at @s if score Stage Global matches 6 unless block ~ 53 ~ barrier run tp @s 540 3 580

# Detect if a pathy's route is invalid, and if so run the failed_test function or if their killDelay score goes above 150
execute as @e[tag=pathy] at @s unless block ~ ~ ~ #minecraft:valid_blocks run function pather:stages/failed_test
execute as @e[tag=pathy,scores={killDelay=150..}] at @s run function pather:stages/failed_test

# Modify data of dropped path blocks to make them placeable in adventure mode
execute as @e[type=item,nbt={Item:{id:"minecraft:light_blue_terracotta",Count:1b}}] at @s run data merge entity @s {Item:{id:"minecraft:light_blue_terracotta",Count:1b,tag:{CanPlaceOn:["minecraft:stone","minecraft:polished_diorite"]}}}
execute as @e[type=item,nbt={Item:{id:"minecraft:purple_terracotta",Count:1b}}] at @s run data merge entity @s {Item:{id:"minecraft:purple_terracotta",Count:1b,tag:{CanPlaceOn:["minecraft:stone","minecraft:polished_diorite"]}}}
execute as @e[type=item,nbt={Item:{id:"minecraft:magenta_glazed_terracotta",Count:1b}}] at @s run data merge entity @s {Item:{id:"minecraft:magenta_glazed_terracotta",Count:1b,tag:{CanPlaceOn:["minecraft:stone","minecraft:polished_diorite"]}}}

# Handles the reset trigger
scoreboard players enable @a reset
execute as @a[scores={reset=1..}] at @s run function pather:stages/reset

# Handles the test level trigger
scoreboard players enable @a test
execute as @a[scores={test=1..}] at @s run function pather:stages/test_level

effect give @a saturation 360000 80 true
effect give @a instant_health 360000 80 true

# Keep Pathy lit up
execute as @e[tag=pathy] run data merge entity @s {Fire:100s}

# Detect tutorial button presses
execute if block 8 4 0 minecraft:stone_pressure_plate[powered=true] run function pather:explain_paths
execute if block 4 4 0 minecraft:stone_pressure_plate[powered=true] run function pather:explain_game
execute if block 16 4 -1 minecraft:stone_pressure_plate[powered=true] run function pather:explain_reset
execute if block 16 4 1 minecraft:stone_pressure_plate[powered=true] run function pather:explain_test

# Make players complete tutorial
execute as @a at @s if entity @e[tag=tutorial,distance=..4] run tag @s add tutorial_complete

# Show commands
#title @a actionbar {"text":"'/trigger reset' - Resets Stage | '/trigger test' - Tests Stage","color":"red"}
